<?php

namespace Util;

use Service\Manager\Mongo\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response;

class ZmartChartProperties {

    protected $manager;

    public function __construct(Manager $manager) {
        $this->manager = $manager;
    }

    public function justDoIt(Response $response = null) {
        $filterCriteria = new FilterCriteria("viewProperty");
        $properties = $this->manager->findBy($filterCriteria)->getRows();
        $properties = Utilities::indexByProperty('_id', $properties);
        $filterCriteria = new FilterCriteria("viewType");
        $charts = $this->manager->findBy($filterCriteria)->getRows();
        foreach($charts as &$chart) {
            unset($chart['_id']);
            unset($chart['convertToColumns']);
            unset($chart['label']);
            if(isset($chart['dimensionProperty'])) {
                $chart['dimensionProperty'] = $properties[$chart['dimensionProperty']]['name'];
            }
            if(isset($chart['factProperties'])) {
                foreach($chart['factProperties'] as &$factProperty) {
                    $factProperty = $properties[$factProperty]['name'];
                }
            }
            if(isset($chart['properties'])) {
                foreach($chart['properties'] as &$property) {
                    $property = $properties[$property]['name'];
                }
            }
        }
        if($response) {
            $response->addDataSet(new DataSet('charts', $charts));
        } else {
            echo json_encode($charts);
        }
    }
}